searchNodes=[{"ref":"Bonny.html","title":"Bonny","module":"Bonny","type":"module","doc":"Extend the Kubernetes API and implement CustomResourceDefinitions lifecycles in Elixir."},{"ref":"Bonny.CRD.html","title":"Bonny.CRD","module":"Bonny.CRD","type":"module","doc":"Represents the spec portion of a Kubernetes CustomResourceDefinition manifest. The CustomResourceDefinition API resource allows you to define custom resources. Defining a CRD object creates a new custom resource with a name and schema that you specify. The Kubernetes API serves and handles the storage of your custom resource."},{"ref":"Bonny.CRD.html#api_version/1","title":"Bonny.CRD.api_version/1","module":"Bonny.CRD","type":"function","doc":"Gets group version from CRD spec Examples iex&gt; Bonny.CRD.api_version(%Bonny.CRD{group: &quot;hello.example.com&quot;, version: &quot;v1&quot;, scope: :namespaced, names: %{}}) &quot;hello.example.com/v1&quot;"},{"ref":"Bonny.CRD.html#kind/1","title":"Bonny.CRD.kind/1","module":"Bonny.CRD","type":"function","doc":"CRD Kind or plural name Examples iex&gt; Bonny.CRD.kind(%Bonny.CRD{names: %{plural: &quot;greetings&quot;}, scope: :namespaced, group: &quot;test&quot;, version: &quot;v1&quot;}) &quot;greetings&quot;"},{"ref":"Bonny.CRD.html#to_manifest/1","title":"Bonny.CRD.to_manifest/1","module":"Bonny.CRD","type":"function","doc":"Generates the map equivalent of the Kubernetes CRD YAML manifest --- apiVersion: apiextensions.k8s.io/v1beta1 kind: CustomResourceDefinition metadata: creationTimestamp: null name: widgets.example.com spec: group: example.com names: kind: Widget plural: widgets scope: Namespaced version: v1"},{"ref":"Bonny.CRD.html#t:t/0","title":"Bonny.CRD.t/0","module":"Bonny.CRD","type":"type","doc":"CRD Spec"},{"ref":"Bonny.Config.html","title":"Bonny.Config","module":"Bonny.Config","type":"module","doc":"Operator configuration interface"},{"ref":"Bonny.Config.html#cluster_name/0","title":"Bonny.Config.cluster_name/0","module":"Bonny.Config","type":"function","doc":"K8s.Cluster name used for this operator. Defaults to :default"},{"ref":"Bonny.Config.html#controllers/0","title":"Bonny.Config.controllers/0","module":"Bonny.Config","type":"function","doc":"List of all controller modules to watch. This must be set in config.exs: config :bonny, controllers: [MyController1, MyController2]"},{"ref":"Bonny.Config.html#group/0","title":"Bonny.Config.group/0","module":"Bonny.Config","type":"function","doc":"Kubernetes API Group of this operator"},{"ref":"Bonny.Config.html#labels/0","title":"Bonny.Config.labels/0","module":"Bonny.Config","type":"function","doc":"Labels to apply to all operator resources. Note: These are only applied to the resoures that compose the operator itself, not the resources created by the operator. This can be set in config.exs: config :bonny, labels: %{foo: &quot;bar&quot;, quz: &quot;baz&quot;}"},{"ref":"Bonny.Config.html#name/0","title":"Bonny.Config.name/0","module":"Bonny.Config","type":"function","doc":"The name of the operator. Name must consist of only lowercase letters and hyphens. Defaults to hyphenated mix project app name. E.g.: :hello_operator becomes hello-operator"},{"ref":"Bonny.Config.html#namespace/0","title":"Bonny.Config.namespace/0","module":"Bonny.Config","type":"function","doc":"The namespace to watch for Namespaced CRDs. Defaults to default This can be set via environment variable: BONNY_POD_NAMESPACE=prod iex -S mix Bonny sets BONNY_POD_NAMESPACE on all Kubernetes deployments to the namespace the operator is deployed in."},{"ref":"Bonny.Config.html#service_account/0","title":"Bonny.Config.service_account/0","module":"Bonny.Config","type":"function","doc":"Kubernetes service account name to run operator as. Note: if a kube config file is provided, this service account will still be created and assigned to pods, but the config file auth will be used when making requests to the Kube API. Name must consist of only lowercase letters and hyphens. Defaults to hyphenated mix project app name. E.g.: :hello_operator becomes hello-operator"},{"ref":"Bonny.Controller.html","title":"Bonny.Controller","module":"Bonny.Controller","type":"behaviour","doc":"Bonny.Controller defines controller behaviours and generates boilerplate for generating Kubernetes manifests. A custom controller is a controller that users can deploy and update on a running cluster, independently of the cluster’s own lifecycle. Custom controllers can work with any kind of resource, but they are especially effective when combined with custom resources. The Operator pattern is one example of such a combination. It allows developers to encode domain knowledge for specific applications into an extension of the Kubernetes API. Controllers allow for simple add, modify, delete, and reconcile handling of custom resources in the Kubernetes API."},{"ref":"Bonny.Controller.html#c:add/1","title":"Bonny.Controller.add/1","module":"Bonny.Controller","type":"callback","doc":""},{"ref":"Bonny.Controller.html#c:delete/1","title":"Bonny.Controller.delete/1","module":"Bonny.Controller","type":"callback","doc":""},{"ref":"Bonny.Controller.html#c:modify/1","title":"Bonny.Controller.modify/1","module":"Bonny.Controller","type":"callback","doc":""},{"ref":"Bonny.Controller.html#c:reconcile/1","title":"Bonny.Controller.reconcile/1","module":"Bonny.Controller","type":"callback","doc":""},{"ref":"Bonny.Naming.html","title":"Bonny.Naming","module":"Bonny.Naming","type":"module","doc":"Naming functions"},{"ref":"Bonny.Naming.html#module_to_kind/1","title":"Bonny.Naming.module_to_kind/1","module":"Bonny.Naming","type":"function","doc":"Converts an elixir module name to a string for use as the CRD&#39;s kind. Examples iex&gt; Bonny.Naming.module_to_kind(Pod) &quot;Pod&quot; iex&gt; Bonny.Naming.module_to_kind(Controllers.V1.Pod) &quot;Pod&quot;"},{"ref":"Bonny.Naming.html#module_version/1","title":"Bonny.Naming.module_version/1","module":"Bonny.Naming","type":"function","doc":"Extract the CRD API version from the module name. Defaults to &quot;v1&quot; Examples iex&gt; Bonny.Naming.module_version(Pod) &quot;v1&quot; iex&gt; Bonny.Naming.module_version(Controllers.V1.Pod) &quot;v1&quot; iex&gt; Bonny.Naming.module_version(Controllers.V1Alpha1.Pod) &quot;v1alpha1&quot;"},{"ref":"Bonny.Operator.html","title":"Bonny.Operator","module":"Bonny.Operator","type":"module","doc":"Encapsulates Kubernetes resource manifests for an operator"},{"ref":"Bonny.Operator.html#cluster_role/0","title":"Bonny.Operator.cluster_role/0","module":"Bonny.Operator","type":"function","doc":"ClusterRole manifest"},{"ref":"Bonny.Operator.html#cluster_role_binding/1","title":"Bonny.Operator.cluster_role_binding/1","module":"Bonny.Operator","type":"function","doc":"ClusterRoleBinding manifest"},{"ref":"Bonny.Operator.html#crds/0","title":"Bonny.Operator.crds/0","module":"Bonny.Operator","type":"function","doc":"CRD manifests"},{"ref":"Bonny.Operator.html#deployment/2","title":"Bonny.Operator.deployment/2","module":"Bonny.Operator","type":"function","doc":"Deployment manifest"},{"ref":"Bonny.Operator.html#rules/0","title":"Bonny.Operator.rules/0","module":"Bonny.Operator","type":"function","doc":"ClusterRole rules"},{"ref":"Bonny.Operator.html#service_account/1","title":"Bonny.Operator.service_account/1","module":"Bonny.Operator","type":"function","doc":"ServiceAccount manifest"},{"ref":"Bonny.Reconciler.html","title":"Bonny.Reconciler","module":"Bonny.Reconciler","type":"module","doc":"Requests all of a CRD&#39;s resources and invokes reconcile/1 on the controller module for each resource."},{"ref":"Bonny.Reconciler.html#child_spec/1","title":"Bonny.Reconciler.child_spec/1","module":"Bonny.Reconciler","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"Bonny.Reconciler.html#start_link/1","title":"Bonny.Reconciler.start_link/1","module":"Bonny.Reconciler","type":"function","doc":""},{"ref":"Bonny.Telemetry.html","title":"Bonny.Telemetry","module":"Bonny.Telemetry","type":"module","doc":"List of telemetry events."},{"ref":"Bonny.Telemetry.html#emit/1","title":"Bonny.Telemetry.emit/1","module":"Bonny.Telemetry","type":"function","doc":"Wrapper around :telemetry.execute/3. Prepends :bonnny to all atom lists."},{"ref":"Bonny.Telemetry.html#emit/3","title":"Bonny.Telemetry.emit/3","module":"Bonny.Telemetry","type":"function","doc":""},{"ref":"Bonny.Telemetry.html#events/0","title":"Bonny.Telemetry.events/0","module":"Bonny.Telemetry","type":"function","doc":""},{"ref":"Bonny.Telemetry.html#measure/1","title":"Bonny.Telemetry.measure/1","module":"Bonny.Telemetry","type":"function","doc":"Measures a functions execution time in seconds Examples iex&gt; Bonny.Telemetry.measure fn -&gt; ...&gt; :timer.sleep(1000) ...&gt; &quot;Hello!&quot; ...&gt; end {1.00426, &quot;Hello!&quot;}"},{"ref":"Bonny.Telemetry.DebugLogger.html","title":"Bonny.Telemetry.DebugLogger","module":"Bonny.Telemetry.DebugLogger","type":"module","doc":"A telemetry logger for debugging."},{"ref":"Bonny.Telemetry.DebugLogger.html#handle_event/4","title":"Bonny.Telemetry.DebugLogger.handle_event/4","module":"Bonny.Telemetry.DebugLogger","type":"function","doc":""},{"ref":"Bonny.Watcher.html","title":"Bonny.Watcher","module":"Bonny.Watcher","type":"module","doc":"Dispatches lifecycle functions in response to events from the Kubernetes Watch API for a given controller."},{"ref":"Bonny.Watcher.html#child_spec/1","title":"Bonny.Watcher.child_spec/1","module":"Bonny.Watcher","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"Bonny.Watcher.html#start_link/1","title":"Bonny.Watcher.start_link/1","module":"Bonny.Watcher","type":"function","doc":""},{"ref":"Bonny.Watcher.Impl.html","title":"Bonny.Watcher.Impl","module":"Bonny.Watcher.Impl","type":"module","doc":"Implementation logic for Bonny.Watcher"},{"ref":"Bonny.Watcher.Impl.html#dispatch/2","title":"Bonny.Watcher.Impl.dispatch/2","module":"Bonny.Watcher.Impl","type":"function","doc":"Dispatches an ADDED, MODIFIED, and DELETED events to an controller"},{"ref":"Bonny.Watcher.Impl.html#extract_rv/1","title":"Bonny.Watcher.Impl.extract_rv/1","module":"Bonny.Watcher.Impl","type":"function","doc":""},{"ref":"Bonny.Watcher.Impl.html#get_resource_version/1","title":"Bonny.Watcher.Impl.get_resource_version/1","module":"Bonny.Watcher.Impl","type":"function","doc":"Gets the resource version from the state, or fetches it from Kubernetes API if not present"},{"ref":"Bonny.Watcher.Impl.html#new/1","title":"Bonny.Watcher.Impl.new/1","module":"Bonny.Watcher.Impl","type":"function","doc":"Initialize a Bonny.Watcher state"},{"ref":"Bonny.Watcher.Impl.html#process_line/3","title":"Bonny.Watcher.Impl.process_line/3","module":"Bonny.Watcher.Impl","type":"function","doc":""},{"ref":"Bonny.Watcher.Impl.html#process_lines/2","title":"Bonny.Watcher.Impl.process_lines/2","module":"Bonny.Watcher.Impl","type":"function","doc":""},{"ref":"Bonny.Watcher.Impl.html#watch_for_changes/2","title":"Bonny.Watcher.Impl.watch_for_changes/2","module":"Bonny.Watcher.Impl","type":"function","doc":"Watches a CRD resource for ADDED, MODIFIED, and DELETED events from the Kubernetes API. Streams HTTPoison response to Bonny.Watcher"},{"ref":"Bonny.Watcher.Impl.html#t:t/0","title":"Bonny.Watcher.Impl.t/0","module":"Bonny.Watcher.Impl","type":"type","doc":""},{"ref":"Bonny.Watcher.ResponseBuffer.html","title":"Bonny.Watcher.ResponseBuffer","module":"Bonny.Watcher.ResponseBuffer","type":"module","doc":"Buffers streaming responses from HTTPoison and returns kubernetes watch events as JSON ResponseBuffer implementation borrowed from Kazan&#39;s LineBuffer."},{"ref":"Bonny.Watcher.ResponseBuffer.html#add_chunk/2","title":"Bonny.Watcher.ResponseBuffer.add_chunk/2","module":"Bonny.Watcher.ResponseBuffer","type":"function","doc":"Add an HTTP response chunk to the buffer"},{"ref":"Bonny.Watcher.ResponseBuffer.html#get_lines/1","title":"Bonny.Watcher.ResponseBuffer.get_lines/1","module":"Bonny.Watcher.ResponseBuffer","type":"function","doc":"Returns complete lines of JSON from streaming HTTP Response. Lines are in NDJSON format; each line is a JSON object."},{"ref":"Bonny.Watcher.ResponseBuffer.html#new/0","title":"Bonny.Watcher.ResponseBuffer.new/0","module":"Bonny.Watcher.ResponseBuffer","type":"function","doc":"Create a new ResponseBuffer"},{"ref":"Bonny.Watcher.ResponseBuffer.html#t:t/0","title":"Bonny.Watcher.ResponseBuffer.t/0","module":"Bonny.Watcher.ResponseBuffer","type":"type","doc":""},{"ref":"Mix.Bonny.html","title":"Mix.Bonny","module":"Mix.Bonny","type":"module","doc":"Mix task helpers"},{"ref":"Mix.Bonny.html#app_dir_name/0","title":"Mix.Bonny.app_dir_name/0","module":"Mix.Bonny","type":"function","doc":""},{"ref":"Mix.Bonny.html#app_name/0","title":"Mix.Bonny.app_name/0","module":"Mix.Bonny","type":"function","doc":"Get the OTP app name"},{"ref":"Mix.Bonny.html#no_umbrella!/0","title":"Mix.Bonny.no_umbrella!/0","module":"Mix.Bonny","type":"function","doc":""},{"ref":"Mix.Bonny.html#parse_args/3","title":"Mix.Bonny.parse_args/3","module":"Mix.Bonny","type":"function","doc":"Parse CLI input"},{"ref":"Mix.Bonny.html#render/2","title":"Mix.Bonny.render/2","module":"Mix.Bonny","type":"function","doc":"Render text to a file. Special handling for the path &quot;-&quot; will render to STDOUT"},{"ref":"Mix.Bonny.html#template/1","title":"Mix.Bonny.template/1","module":"Mix.Bonny","type":"function","doc":""},{"ref":"Mix.Tasks.Bonny.Gen.Controller.html","title":"Mix.Tasks.Bonny.Gen.Controller","module":"Mix.Tasks.Bonny.Gen.Controller","type":"task","doc":"Generates a new CRD controller An operator can have multiple controllers. Each controller handles the lifecycle of a custom resource. By default controllers are generated in the V1 version scope. mix bonny.gen.controller Widget widget You can specify the version flag to create a new version of a controller. Bonny will dispatch the controller for the given version. So old versions of resources can live alongside new versions. mix bonny.gen.controller Widget widget --version v2alpha1 Note: The one restriction with versions is that they will be camelized into a module name. Open up your controller and add functionality for your resoures lifecycle: Add Modify Delete Each controller can create multiple resources. For example, a todo app controller could deploy a Deployment and a Service."},{"ref":"Mix.Tasks.Bonny.Gen.Controller.html#run/1","title":"Mix.Tasks.Bonny.Gen.Controller.run/1","module":"Mix.Tasks.Bonny.Gen.Controller","type":"function","doc":"A task needs to implement run which receives a list of command line args. Callback implementation for Mix.Task.run/1."},{"ref":"Mix.Tasks.Bonny.Gen.Dockerfile.html","title":"Mix.Tasks.Bonny.Gen.Dockerfile","module":"Mix.Tasks.Bonny.Gen.Dockerfile","type":"task","doc":"Generates a Dockerfile for this operator"},{"ref":"Mix.Tasks.Bonny.Gen.Dockerfile.html#run/1","title":"Mix.Tasks.Bonny.Gen.Dockerfile.run/1","module":"Mix.Tasks.Bonny.Gen.Dockerfile","type":"function","doc":"A task needs to implement run which receives a list of command line args. Callback implementation for Mix.Task.run/1."},{"ref":"Mix.Tasks.Bonny.Gen.Manifest.html","title":"Mix.Tasks.Bonny.Gen.Manifest","module":"Mix.Tasks.Bonny.Gen.Manifest","type":"task","doc":"Generates the Kubernetes YAML manifest for this operator mix bonny.gen.manifest expects a docker image name if deploying to a cluster. You may optionally provide a namespace. Examples The image switch is required. Options: --image (docker image to deploy) --namespace (of service account and deployment; defaults to &quot;default&quot;) --out (path to save manifest; defaults to &quot;manifest.yaml&quot;) Deploying to kubernetes: docker build -t $(YOUR_IMAGE_URL) . docker push $(YOUR_IMAGE_URL) mix bonny.gen.manifest --image $(YOUR_IMAGE_URL):latest --namespace default kubectl apply -f manifest.yaml -n default To skip the deployment for running an operator outside of the cluster (like in development) simply omit the --image flag: mix bonny.gen.manifest"},{"ref":"Mix.Tasks.Bonny.Gen.Manifest.html#run/1","title":"Mix.Tasks.Bonny.Gen.Manifest.run/1","module":"Mix.Tasks.Bonny.Gen.Manifest","type":"function","doc":"A task needs to implement run which receives a list of command line args. Callback implementation for Mix.Task.run/1."},{"ref":"readme.html","title":"Bonny: Kubernetes Operator Framework","module":"readme","type":"extras","doc":"Bonny: Kubernetes Operator Framework Extend the Kubernetes API and implement CustomResourceDefinitions lifecycles in Elixir. If Kubernetes CRDs and controllers are new to you, read up on the terminology. Tutorials and Examples: HelloOperator Tutorial Part: 1 2 3 HelloOperator source code"},{"ref":"readme.html#installation","title":"Bonny: Kubernetes Operator Framework - Installation","module":"readme","type":"extras","doc":"If available in Hex, the package can be installed by adding bonny to your list of dependencies in mix.exs: def deps do [ {:bonny, &quot;~&gt; 0.3&quot;} ] end Configuration Bonny uses the k8s client under the hood. The only configuration parameters required are :bonny controllers and a :k8s cluster: config :k8s, clusters: %{ default: %{ # `default` here must match `cluster_name` below conf: &quot;~/.kube/config&quot; } } config :bonny, # Add each CRD Controller module for this operator to load here # Defaults to none. This *must* be set. controllers: [ MyApp.Controllers.V1.WebServer, MyApp.Controllers.V1.Database, MyApp.Controllers.V1.Memcached ], # K8s.Cluster to use, defaults to :default cluster_name: :default, # How often to run the reconciler for all controllers in milliseconds. # Default: 300000ms (5 minutes) reconcile_every: 10 * 60 * 1000, # Batch size of HTTP request; maps to the Kubernetes `limit` API parameter. # If `continue` is returned additional HTTP requests will be made to fetch all batches of items # Default: 50 reconcile_batch_size: 100, # Set the Kubernetes API group for this operator. # This can be overwritten using the @group attribute of a controller group: &quot;your-operator.example.com&quot;, # Name must only consist of only lowercase letters and hyphens. # Defaults to hyphenated mix app name operator_name: &quot;your-operator&quot;, # Name must only consist of only lowercase letters and hyphens. # Defaults to hyphenated mix app name service_account_name: &quot;your-operator&quot;, # Labels to apply to the operator&#39;s resources. labels: %{ &quot;kewl&quot;: &quot;true&quot; }, # Operator deployment resources. These are the defaults. resources: %{ limits: %{cpu: &quot;200m&quot;, memory: &quot;200Mi&quot;}, requests: %{cpu: &quot;200m&quot;, memory: &quot;200Mi&quot;} } When configuring bonny to run in your cluster the mix bonny.gen.manifest command will generate a service account for you. To use that service account configure the k8s library like the following: config :k8s, clusters: %{ default: %{} } This will add a cluster named default. When no configuration information is provided, the k8s library will use the service account of the pod."},{"ref":"readme.html#example-operators-built-with-bonny","title":"Bonny: Kubernetes Operator Framework - Example Operators built with Bonny","module":"readme","type":"extras","doc":"Hello Operator - this was built with bonny v 0.2, there have been significant changes since."},{"ref":"readme.html#bonny-generators","title":"Bonny: Kubernetes Operator Framework - Bonny Generators","module":"readme","type":"extras","doc":"There are a number of generators to help create a kubernetes operator. mix help | grep bonny Generating an operator controller An operator can have multiple controllers. Each controller handles the lifecycle of a custom resource. By default controllers are generated in the V1 version scope. mix bonny.gen.controller Widget widgets You can specify the version flag to create a new version of a controller. Bonny will dispatch the controller for the given version. So old versions of resources can live alongside new versions. mix bonny.gen.controller Widget widgets --version v2alpha1 Note: The one restriction with versions is that they will be camelized into a module name. Open up your controller and add functionality for your resource&#39;s lifecycles: Add Modify Delete Reconcile; periodically called with each every instance of a CRD&#39;s resources Each controller can create multiple resources. For example, a todo app controller could deploy a Deployment and a Service. Your operator can also have multiple controllers if you want to support multiple resources in your operator! Check out the two test controllers: Cog Widget Generating a dockerfile The following command will generate a dockerfile for your operator. This will need to be pushed to a docker repository that your kubernetes cluster can access. Again, this Dockerfile is for your operator, not for the pods your operator may deploy. You can skip this step when developing by running your operator external to the cluster. mix bonny.gen.dockerfile export BONNY_IMAGE=YOUR_IMAGE_NAME_HERE docker build -t ${BONNY_IMAGE} . docker push ${BONNY_IMAGE}:latest Generating Kubernetes manifest for operator This will generate the entire manifest for this operator including: CRD manifests RBAC Service Account Operator Deployment The operator manifest generator requires the image flag to be passed if you plan to deploy the operator in your cluster. This is the docker image URL of your operators docker image created by mix bonny.gen.docker above. mix bonny.gen.manifest --image ${BONNY_IMAGE} You may omit the --image flag if you want to generate a manifest without the deployment so that you can develop locally running the operator outside of the cluster. Note: YAML output is JSON formatted YAML. Sorry, elixirland isn&#39;t fond of YAML :D By default the manifest will generate the service account and deployment in the &quot;default&quot; namespace. To set the namespace explicitly: mix bonny.gen.manifest --out - -n test Alternatively you can apply it directly to kubectl: mix bonny.gen.manifest --out - -n test | kubectl apply -f - -n test Generating a resource TODO: Need to support validation / OpenAPI. https://github.com/coryodaniel/bonny/issues/9 https://github.com/coryodaniel/bonny/issues/10"},{"ref":"readme.html#telemetry","title":"Bonny: Kubernetes Operator Framework - Telemetry","module":"readme","type":"extras","doc":"Bonny uses the telemetry library to emit event metrics. Emmited events: [:bonny, :reconciler, :genserver_initialized], [:bonny, :reconciler, :started], [:bonny, :reconciler, :scheduled], [:bonny, :reconciler, :get_items_succeeded], [:bonny, :reconciler, :get_items_failed], [:bonny, :reconciler, :item_succeeded], [:bonny, :reconciler, :item_failed], [:bonny, :watcher, :genserver_initialized], [:bonny, :watcher, :genserver_down], [:bonny, :watcher, :started], [:bonny, :watcher, :chunk_received], [:bonny, :watcher, :expired], [:bonny, :watcher, :finished], [:bonny, :watcher, :http_request_failed], [:bonny, :watcher, :http_request_succeeded], [:bonny, :watcher, :dispatch_succeeded], [:bonny, :watcher, :dispatch_failed]"},{"ref":"readme.html#terminology","title":"Bonny: Kubernetes Operator Framework - Terminology","module":"readme","type":"extras","doc":"Custom Resource: A custom resource is an extension of the Kubernetes API that is not necessarily available on every Kubernetes cluster. In other words, it represents a customization of a particular Kubernetes installation. CRD Custom Resource Definition: The CustomResourceDefinition API resource allows you to define custom resources. Defining a CRD object creates a new custom resource with a name and schema that you specify. The Kubernetes API serves and handles the storage of your custom resource. Controller: A custom controller is a controller that users can deploy and update on a running cluster, independently of the cluster’s own lifecycle. Custom controllers can work with any kind of resource, but they are especially effective when combined with custom resources. The Operator pattern is one example of such a combination. It allows developers to encode domain knowledge for specific applications into an extension of the Kubernetes API. Operator: A set of application specific controllers deployed on Kubernetes and managed via kubectl and the Kubernetes API."},{"ref":"readme.html#docs","title":"Bonny: Kubernetes Operator Framework - Docs","module":"readme","type":"extras","doc":"Documentation can be generated with ExDoc and published on HexDocs. Once published, the docs can be found at https://hexdocs.pm/bonny."},{"ref":"readme.html#testing","title":"Bonny: Kubernetes Operator Framework - Testing","module":"readme","type":"extras","doc":"mix test"},{"ref":"readme.html#operator-blog-posts","title":"Bonny: Kubernetes Operator Framework - Operator Blog Posts","module":"readme","type":"extras","doc":"Why Kubernetes Operators are a game changer"},{"ref":"changelog.html","title":"Changelog","module":"changelog","type":"extras","doc":"Changelog All notable changes to this project will be documented in this file. The format is based on Keep a Changelog, and this project adheres to Semantic Versioning."},{"ref":"changelog.html#unreleased","title":"Changelog - [Unreleased]","module":"changelog","type":"extras","doc":""},{"ref":"changelog.html#0-3-3-2019-06-25","title":"Changelog - [0.3.3] - 2019-06-25","module":"changelog","type":"extras","doc":"Added Add additional printer columns Bonny.Naming module .credo.exs"},{"ref":"changelog.html#0-3-2-2019-04-15","title":"Changelog - [0.3.2] - 2019-04-15","module":"changelog","type":"extras","doc":"Added Bonny.Watcher and Bonny.Reconciler telemetry events"},{"ref":"changelog.html#0-3-1-2019-04-11","title":"Changelog - [0.3.1] - 2019-04-11","module":"changelog","type":"extras","doc":"Added Support for a reconcile/1 callback reconcile_every config option to schedule how often to run reconciliation reconcile_batch_size to set the size of the HTTP GET limit when fetching batches of items to reconcile Added {:error, binary} as a return value of Controller lifecycle methods Implemented :telemetry library Bonny.Telemetry.events/0 exposes list of telemetry events mix bonny.gen.manifest --local for building manifests w/o a Deployment for local testing cluster_name: :default config options. Now uses k8s cluster registration configuration. Changed Async watcher event dispatch Replaced HTTPoison with k8s Fixed Receiving :DOWN messages no longer crashes Watcher #20 Issue with partially received events #43 Fix invalid singular name generation from module names &quot;MyMod&quot; -&gt; my_mod; &quot;MyMod&quot; -&gt; mymod Removed Renamed group_version -&gt; api_version Renamed Bonny.CRD.plural/1 -&gt; Bonny.CRD.kind/1 Bypass from test suite Impl.parse_metadata/1 kubeconf_file and kubeconf_opts config options"},{"ref":"changelog.html#0-3-0-2019-03-04","title":"Changelog - [0.3.0] - 2019-03-04","module":"changelog","type":"extras","doc":"Changed Replaced k8s_conf library with k8s."},{"ref":"changelog.html#0-2-3-2019-01-13","title":"Changelog - [0.2.3] - 2019-01-13","module":"changelog","type":"extras","doc":"Added Initial public release. Controller lifecycle implementation. CRD Watcher. mix task: controller generator mix task: dockerfile generator mix task: k8s manifest generator"}]